/* Mller Matthias simmmuel Diplominformatik */
/* Lenz Sebastian siselenz Diplominformatik */
/* Lsung Aufgabe 5 - trsh */
/* 22.12.03 - 07.01.04 */

/* TODO: there could be race conditions when dealing */
/* with done_joblist, to be fixed... */

/* WARNING: joblist.c leaks, is buggy and could originally not be compiled !!! */

/* includes */
/* MYSH */
#include <errno.h>                  /* perror */
#include <stdlib.h>                 /* malloc */
#include <stdio.h>                  /* fgets */
#include <unistd.h>                 /* sysconf */
#include <sys/types.h>              /* fork */
#include <sys/wait.h>               /* wait */
#include <string.h>                 /* strlen */
/* END OF MYSH */
/* TRSH */
#include "joblist.h"                /* [joblist stuff] */
#include <signal.h>                 /* [signal handler] */
#include <sys/times.h>              /* times */
/* END OF TRSH */

/* defines */
/* TRSH */
#define COLLECTED_CHILD_ERROR   0   /* error collecting child */
#define COLLECTED_CHILD_NOTHING 1   /* nothing was collected */
#define COLLECTED_CHILD_UNKNOWN 2   /* collected child was NOT in joblist */
#define COLLECTED_CHILD_KNOWN   3   /* collected child WAS in joblist */
/* END OF TRSH */

/* prototypes */
/* MYSH */
int main();
int mysh_getline(char **);
int mysh_processline(char *);
int line_to_arg(const char *line, int *argc, char ***argv);
void line_replace_newline(char **);
void arg_free(int *argc, char ***argv, char **line_original);
/* END OF MYSH */
/* TRSH */
int line_replace_background_process(char **line);
void signal_handler(int signal);
int collect_child(int *wait_status);
/* END OF TRSH */

/* global vars */
/* TRSH */
jl_t joblist; /* saves process ids and original command lines of currently working child processes */
jl_t done_joblist; /* saves exit statuses and original command lines of finished, collected child processes */
int foreground_process_working=0; /* if the SIGCHLD signal must NOW NOT be processed */
int foreground_process_id=0;
/* END OF TRSH */

int main()
{
    struct sigaction sigaction_var;
    char *line=NULL;

    /* preset */

    errno=0;

    joblist=jl_new();
    if (joblist==NULL)
    {
        fprintf(stderr, "Error creating joblist !");
        exit(-1);
    }

    done_joblist=jl_new();
    if (done_joblist==NULL)
    {
        fprintf(stderr, "Error creating done_joblist !");
        if (jl_delete(joblist)==(-1))
            fprintf(stderr, "Error deleting joblist !");
        exit(-1);
    }

    /* SIGNAL HANDLER #1: parent process processes SIGINT signal */
    sigaction_var.sa_handler = signal_handler;
    sigemptyset(&sigaction_var.sa_mask);
    sigaction_var.sa_flags = SA_RESTART;

    errno=0; /* may have been set by any signal handler */
    if (sigaction(SIGINT, &sigaction_var, NULL)!=0)
    {
        perror("Error in sigaction() in main (SIGINT)") ;
        if (jl_delete(joblist)==(-1))
            fprintf(stderr, "Error deleting joblist !");
        if (jl_delete(done_joblist)==(-1))
            fprintf(stderr, "Error deleting done_joblist !");
        exit(-1);
    }

    /* SIGNAL HANDLER #2: parent process processes SIGCHLD signal */
    sigaction_var.sa_handler = signal_handler;
    sigemptyset(&sigaction_var.sa_mask);
    sigaction_var.sa_flags = SA_RESTART | SA_NOCLDSTOP; /* call signal handler only when child terminates, not when being stopped */

    errno=0; /* may have been set by some signal handler */
    if (sigaction(SIGCHLD, &sigaction_var, NULL)!=0)
    {
        perror("Error in sigaction() in main (SIGCHLD)") ;
        if (jl_delete(joblist)==(-1))
            fprintf(stderr, "Error deleting joblist !");
        if (jl_delete(done_joblist)==(-1))
            fprintf(stderr, "Error deleting done_joblist !");
        exit (-1);
    }

    /* begin */
    while(1)
    {
        switch (mysh_getline(&line))
        {
        case 0:
        {
            perror("Error in trsh_getline()");
            if (line!=NULL) free(line); /* maybe error in malloc() */
            line=NULL;
            if (jl_delete(joblist)==(-1))
                fprintf(stderr, "Error deleting joblist !");
            if (jl_delete(done_joblist)==(-1))
                fprintf(stderr, "Error deleting done_joblist !");
            exit(-1);
        }
        case 2:
        {
            printf("\n");
            if (line!=NULL) free(line); /* maybe reset by fgets() */
            line=NULL;
            if (jl_delete(joblist)==(-1))
                fprintf(stderr, "Error deleting joblist !");
            if (jl_delete(done_joblist)==(-1))
                fprintf(stderr, "Error deleting done_joblist !");
            return 0;
        }
        }
        switch (mysh_processline(line))
        {
        case 0:
        {
            perror("Error in trsh_processline()");
            free(line);
            line=NULL;
            if (jl_delete(joblist)==(-1))
                fprintf(stderr, "Error deleting joblist !");
            if (jl_delete(done_joblist)==(-1))
                fprintf(stderr, "Error deleting done_joblist !");
            exit(-1);
            break;
        }
        case 3:
        {
            free(line);
            line=NULL;
            if (jl_delete(joblist)==(-1))
                fprintf(stderr, "Error deleting joblist !");
            if (jl_delete(done_joblist)==(-1))
                fprintf(stderr, "Error deleting done_joblist !");
            exit(-1);
            break;
        }
        }

        free(line); /* free before next use */
        line=NULL;
    }

    /* we should never reach this point... */
    if (jl_delete(joblist)==(-1))
        fprintf(stderr, "Error deleting joblist !");
    if (jl_delete(done_joblist)==(-1))
        fprintf(stderr, "Error deleting done_joblist !");

    return 0;
}

int mysh_getline(char **line)
{
    /* returns 1 for success or 0 for error or 2 for user abort */

    char *line_original=NULL; /* used for freeing only */
    int line_length_max=0; /* max. length of command line */

    /* reset */
    errno=0; /* reset in any case as used to check for new errors */

    /* begin */
    line_length_max=sysconf(_SC_ARG_MAX);
    if (line_length_max==(-1))
        return 0;

    /* initialize line */
    *line=(char *)malloc(line_length_max*sizeof(char));
    if ((*line)==NULL)
        return 0;

    /* read line */
    /* printf("trash> "); */
    printf("trsh> ");
    line_original=*line;
    *line=fgets(*line, line_length_max, stdin);

    if ((*line)==NULL) /* seg. fault if using fgets() here */
    {
        if (line_original!=NULL) free(line_original); /* important, or leaking */
        if (errno==0)
            return 2;
        else
            return 0;
    }

    return 1;
}

int mysh_processline(char *line)
{
    /* returns 1 for success or 0 for error or 3 for end process */

    int argc=0; /* number of program arguments */
    char **argv=NULL; /* program arguments */
    /* int arg_for=0; */

    struct sigaction sigaction_var;
    pid_t fork_process_id=0;
    int is_background_process=0;

    char *line_original; /* copy of passed line containing &, but not \n */

    char *jl_info;
    int jl_pid;
    char *done_jl_info;
    int done_jl_pid;

    int wait_status=0;

    /* begin; prepare forking... */
    line_replace_newline(&line); /* replace first \n through \0 */

    line_original=(char *)malloc(strlen(line)+1); /* line is guaranteed to be null-terminated, +1 for null termination */
    if (line_original==NULL)
    {
        perror("Error allocating memory for line_original in mysh_processline()");
        errno=0;
        line_original=line; /* & sign may be cut */
    }
    else
        strcpy(line_original, line);

    is_background_process=line_replace_background_process(&line); /* may replace & through \n */

    if (line_to_arg(line, &argc, &argv)==0)
    {
        arg_free(&argc, &argv, &line_original); /* free up memory */
        return 0;
    }

    /*
    for (arg_for=0; arg_for<argc; arg_for++)
        printf("Parameter: >%s<\n", argv[arg_for]); */

    /* CHECK FOR SPECIAL INPUT */
    if (argv[0]==NULL) /* if user just pressed return */
    {
        arg_free(&argc, &argv, &line_original); /* free up memory */
        return 1;
    }

    if (strcmp(argv[0], "jobs")==0) /* works also for '   jobs     blah blah' */
    {
        for(jl_rewind(joblist); jl_next(joblist, &jl_pid, &jl_info) != -1; )
        {
            printf("%d\t", jl_pid);
            printf("%s\n", jl_info);
        }
        arg_free(&argc, &argv, &line_original); /* free up memory */
        return 1;
    }

    /* END OF CHECKING FOR SPECIAL INPUT */

    /* alright, now fork... */

    if (is_background_process==0)
        foreground_process_working=1; /* set before forking as signal may arrive right after forking */
    else
        foreground_process_working=0; /* verify reset */

    fork_process_id=fork();
    if (fork_process_id==(pid_t)0)
    {
        /* child */

        /* SIGNAL HANDLER #3: child process processes (ignores) SIGINT signal */
        sigaction_var.sa_handler = SIG_IGN; /* signal_handler; */
        sigemptyset(&sigaction_var.sa_mask);
        sigaction_var.sa_flags = 0;

        errno=0; /* may have been set by any signal handler */
        if (sigaction(SIGINT, &sigaction_var, NULL)!=0)
        {
            perror("Error in sigaction() in mysh_processline() (SIGINT)") ;
            arg_free(&argc, &argv, &line_original); /* free up memory */
            return 3; /* end child process */
        }

        execvp(argv[0], &argv[0]); /* don't do when user pressed just return or invalid read of size 1 (reported by valgrind) */

        fprintf(stderr, "trsh: error executing: %s\n", argv[0]);

        arg_free(&argc, &argv, &line_original); /* free up memory */
        return 3; /* end child process */
    }
    else if (fork_process_id!=(pid_t)(-1))
    {
        /* parent */
        if (is_background_process==0)
        {
            /* NOTE: the started process is no background process, */
            /* wait for it... */

            /* temporary disable special SIGCHLD processing, we permanently collect children in loop now */
            sigaction_var.sa_handler = SIG_DFL;
            sigemptyset(&sigaction_var.sa_mask);
            sigaction_var.sa_flags = 0;

            errno=0; /* may have been set by any signal handler */
            if (sigaction(SIGCHLD, &sigaction_var, NULL)!=0)
            {
                perror("Error in sigaction() in mysh_processline() (SIGCHILD off)") ;
                arg_free(&argc, &argv, &line_original); /* free up memory */
                return 3; /* end child process */
            }

            foreground_process_working=1; /* also set before forking (here again for better control) */
            foreground_process_id=fork_process_id;

            while(1)
            {
                /* the current child process we must wait for is NOT in joblist, as no background process */
                /* we must still log the background processes, we cannot just use waitpid() as then the logging etc. would fail */
                if (collect_child(&wait_status)==COLLECTED_CHILD_UNKNOWN) break;
            }

            /* restore special SIGCHLD handling */
            sigaction_var.sa_handler = signal_handler;
            sigemptyset(&sigaction_var.sa_mask);
            sigaction_var.sa_flags = SA_RESTART | SA_NOCLDSTOP; /* call signal handler only when child terminates, not when being stopped */

            errno=0; /* may have been set by any signal handler */
            if (sigaction(SIGCHLD, &sigaction_var, NULL)!=0)
            {
                perror("Error in sigaction() in mysh_processline() (SIGCHILD on)") ;
                arg_free(&argc, &argv, &line_original); /* free up memory */
                return 3; /* end child process */
            }

            /* print exit status of CURRENT foreground process */
            fprintf(stderr, "Exitstatus [%s] = %d\n", line, wait_status);

            foreground_process_working=0; /* reset (here, before displaying and resetting done_joblist content) */
            /* from now on collected children are displayed INSTANTLY again */

            /* print exit statuses of background processes that already exited */
            for(jl_rewind(done_joblist); jl_next(done_joblist, &done_jl_pid, &done_jl_info)!=(-1); )
            {
                fprintf(stderr, "Exitstatus [%s] = %d\n", done_jl_info, done_jl_pid);
            }

            /* remove ALL done jobs */
            jl_rewind(done_joblist);
            while(jl_next(done_joblist, &done_jl_pid, &done_jl_info)!=(-1))
            {
                if (jl_remove(done_joblist)==(-1)) /* remove the element that was recently returned by jl_next() */
                {
                    fprintf(stderr, "Error removing entry from done_joblist !");
                    /* continue */
                }
                else
                    jl_rewind(done_joblist);
            }

            /* the following line is necessary to collect exited background process-zombies if */
            /* there was a foreground and several background processes, and the user pressed Strg-C */
            while (collect_child(&wait_status)!=COLLECTED_CHILD_NOTHING);

            arg_free(&argc, &argv, &line_original); /* free up memory */
            return 1;
        }
        else
        {
            /* NOTE: the started process IS a background process, */
            /* add data to joblist and continue... */

            if (jl_insert(joblist, fork_process_id, line_original)==(-1)) /* joblist copies line to own memory */
            {
                fprintf(stderr, "Error adding job to joblist in mysh_processline() !");
                arg_free(&argc, &argv, &line_original); /* free up memory */
                return 3; /* end child process */
            }

            arg_free(&argc, &argv, &line_original); /* free up memory */
            return 1;
        }
    }
    else
    {
        /* error */
        arg_free(&argc, &argv, &line_original); /* free up memory */
        return 0;
    }
}

void arg_free(int *argc, char ***argv, char **line_original)
{
    /* frees all memory in passed 'argument array' */

    int arg_for=0;

    if ((*argv)!=NULL)
    {
        for (arg_for=0; arg_for<(*argc); arg_for++)
        {
            if ((*argv)[arg_for]!=NULL) /* don't free non-existing memory of null pointer(s) */
            {
                free((*argv)[arg_for]); /* free data pointers are pointing on */
                (*argv)[arg_for]=NULL;
            }
        }
        free((*argv)); /* free array of pointers */
    }

    (*argc)=0;

    if (*line_original!=NULL)
    {
        free(*line_original);
        *line_original=NULL;
    }
}

int line_to_arg(const char *line, int *argc, char ***argv)
{
    /* creates an 'argument array' out of a command line; returns 1 for success or 0 for error */

    char *arg=NULL;
    int arg_start_pos=0;
    int arg_end_pos=0;
    int line_length=0;
    int line_for=0;

    /* NOTE: arguments are bordered by space chars. */

    line_length=strlen(line);

    arg_start_pos=0; /* preset */
    (*argc)=0; /* preset */

    /* create argument array out of inputted line */
    for (line_for=0; line_for<line_length; line_for++)
    {
        if ((line[line_for]==' ')||(line[line_for]=='\n')||(line_for==(line_length-1)))
        {
            if ((line[line_for]==' ')||(line[line_for]=='\n'))
                arg_end_pos=line_for-1;
            else
            {
                arg_end_pos=line_for; /* end of line reached (could happen as we replaced \n through \0 and strlen() returns truncated line length) */
            }

            if (arg_end_pos>=arg_start_pos)
            {
                arg=(char *)malloc((arg_end_pos-arg_start_pos+1+1)*sizeof(char)); /* 1 char for null termination */
                if (arg==NULL) return 0;

                memset(arg, 0, (arg_end_pos-arg_start_pos+1+1));
                strncpy(arg, (line+arg_start_pos), (arg_end_pos-arg_start_pos+1));

                (*argc)++;
                (*argv)=(char **)realloc((void *)*argv, (*argc)*sizeof(char **));
                if (argv==NULL) return 0;
                (*argv)[(*argc)-1]=arg;
            }
            arg_start_pos=line_for+1;
        }
    }

    /* add a null pointer required by execvp() */
    (*argc)++;
    (*argv)=(char **)realloc((void *)*argv, (*argc)*sizeof(char **));
    if (argv==NULL) return 0;
    (*argv)[(*argc)-1]=NULL;

    return 1;
}

void line_replace_newline(char **line)
{
    /* replaces first \n through \0; line may have length 0 */

    int line_length=0;
    int line_for=0;

    line_length=strlen(*line);
    if (line_length>0)
    {
        for (line_for=0; line_for<line_length; line_for++)
        {
            if ((*line)[line_for]=='\n')
            {
                (*line)[line_for]='\0';
                break;
            }
        }
    }
}

/* TRSH SPECIFIC CODE */

int line_replace_background_process(char **line)
{
    /* returns 1 if line is &-terminated or 0 if not, replaces first & through \0 */

    int line_length=0;
    int line_for=0;

    line_length=strlen(*line);
    if (line_length)
    {
        for (line_for=line_length-1; line_for>=0; line_for--)
        {
            if ((*line)[line_for]>32) /* space, null char, tab and newline are ignored */
            {
                if ((*line)[line_for]=='&')
                {
                    (*line)[line_for]='\0';
                    return 1;
                }
                else
                    return 0;
            }
        }
    }
    return 0;
}

void signal_handler(int signal)
{
    /* receives signals of parent- and child processes */

    int wait_status=0;

    char *jl_info;
    int jl_pid=0;

    switch (signal)
    {
    case SIGCHLD: /* status of a child changed */
    {
        while (collect_child(&wait_status)!=COLLECTED_CHILD_NOTHING); /* when having run SEVERAL background processes and pressing Strg-C then we must use a loop to collect ALL children (tested) */
        return;
    }
    case SIGINT: /* we got an interrupt signal; we must be the parent, children ignore this signal */
    {
        /* parent sends a SIGQUIT signal to all its children */
        fprintf(stderr, "Interrupt!\n");

        /* kill(-1, SIGQUIT); */ /* hell no! don't do that or EVERYTHING will shut down... */

        /* kill any foreground process */
        if (foreground_process_working)
            kill(foreground_process_id, SIGQUIT);

        /* kill all background processes */
        for(jl_rewind(joblist); jl_next(joblist, &jl_pid, &jl_info)!=(-1); )
        {
            kill((pid_t)jl_pid, SIGQUIT);
        }

        if (foreground_process_working==0) /* SIGINT handler already printed command prompt */
        {
            printf("trsh> ");
            fflush(stdout);
        }

        return;
    }
    }
    return;
}

int collect_child(int *wait_status)
{
    /* collects children; returns a COLLECTED_CHILD value */

    pid_t wait_pid;

    char *jl_info;
    int jl_pid=0;

    struct tms tms_var_1;
    struct tms tms_var_2;
    clock_t clocks_per_second=0;
    int usertime_seconds=0;
    int usertime_milliseconds=0;
    int systemtime_seconds=0;
    int systemtime_milliseconds=0;

    FILE *logfile_descr;

    /* begin, save process time BEFORE being collected */
    clocks_per_second=(clock_t)sysconf(_SC_CLK_TCK);

    if (times(&tms_var_1)==(-1))
    {
        perror("Error in times() in signal_handler() (1)");
        return COLLECTED_CHILD_ERROR;
    }

    while ((wait_pid=waitpid (-1, wait_status, WNOHANG))>0)
    {
        /* if (WIFEXITED(wait_status))
        {
            printf("Child exited normally.\n");
        }
        if (WIFSIGNALED(wait_status))
        {
            printf("Child exited due to a signal.\n");
        }
        */

        /* save time information for current process */
        if (times(&tms_var_2)==(-1))
        {
            perror("Error in times() in signal_handler() (2)");
            return COLLECTED_CHILD_ERROR;
        }
        usertime_milliseconds=(int)((clock_t)1000*(tms_var_2.tms_cutime-tms_var_1.tms_cutime)/clocks_per_second);
        usertime_seconds=(usertime_milliseconds/(int)1000); /* (999->0, 1000->1, 1999->1, 2000->2) */
        usertime_milliseconds-=usertime_seconds*(int)1000;
        systemtime_milliseconds=(int)((clock_t)1000*(tms_var_2.tms_cstime-tms_var_1.tms_cstime)/clocks_per_second);
        systemtime_seconds=(systemtime_milliseconds/(int)1000); /* (999->0, 1000->1, 1999->1, 2000->2) */
        systemtime_milliseconds-=systemtime_seconds*(int)1000;

        /* check which job in list is the one that got the signal */
        for(jl_rewind(joblist); jl_next(joblist, &jl_pid, &jl_info)!=(-1); )
        {
            if (jl_pid==wait_pid) /* only processes added to joblist (background processes) will be processed in following block */
            {
                /* open logfile */
                logfile_descr=fopen("log.txt", "a");
                if (logfile_descr==NULL)
                {
                    perror("Error opening logfile 'log.txt'");
                    errno=0; /* reset as we continue execution */
                }

                /* print process status */
                if (foreground_process_working==0)
                {
                    printf("\n");
                    printf("Exitstatus [%s] = %d\n", jl_info, *wait_status);
                }
                else
                {
                    if (jl_insert(done_joblist, *wait_status, jl_info)==(-1)) /* joblist copies line to own memory */
                    {
                        fprintf(stderr, "Error adding job to done_joblist !");
                        /* continue, much other stuff to do */
                    }
                }

                /* print data to logfile */
                fprintf(logfile_descr, "%d\t%d\t%d:%d\t%d:%d\t%s\n",
                        jl_pid,
                        *wait_status,
                        usertime_seconds,
                        usertime_milliseconds,
                        systemtime_seconds,
                        systemtime_milliseconds,
                        jl_info);

                /* close logfile */
                if (logfile_descr!=NULL)
                {
                    if (fclose(logfile_descr)!=0)
                    {
                        perror("Error closing logfile");
                        errno=0; /* reset as we continue program execution */
                    }
                }

                /* display prompt symbol, last screen output was process information */
                if (foreground_process_working==0)
                {
                    /* printf("trsh> ");
                    fflush(stdout); */ /* important, or trsh> won't be displayed */ /* sometimes doubled together with SIGINT-trsh> */
                }

                /* remove job */
                if (jl_remove(joblist)==(-1)) /* remove the element that was recently returned by jl_next() */
                {
                    fprintf(stderr, "Error removing entry from joblist !");
                    return COLLECTED_CHILD_ERROR;
                }

                /* end of processing known child */
                return COLLECTED_CHILD_KNOWN;
            }
        }
        return COLLECTED_CHILD_UNKNOWN;
    }
    return COLLECTED_CHILD_NOTHING;
}

/* END OF TRSH SPECIFIC CODE */
