/* Mller Matthias simmmuel Diplominformatik */
/* Aufgabe 7 - port_forward */

#include "forward.h"

#include <stdio.h>      /* perror */
#include <malloc.h>     /* malloc */
#include <errno.h>      /* errno */
#include <string.h>     /* memcpy */
#include <sys/select.h> /* select */
#include <sys/time.h>   /* select */
#include <sys/types.h>  /* select */
#include <unistd.h>     /* select */

void free_forward_fnct_memory(fd_set **write_fds, fd_set **read_fds, char **buffer1, char **buffer2);

int forward(int fd1, int fd2)
{
    int fd_max=0; /* mysterious value created out of larger of both file descriptors */
    fd_set *read_fds=NULL;
    fd_set *write_fds=NULL;
    int fd1_closed=0;
    int fd2_closed=0;
    int select_retval=0;
    char *buffer1=NULL;
    char *buffer2=NULL;
    int buffer_size_used1=0;
    int buffer_size_used2=0;
    int temp=0;

    /* preset */
    errno=0;

    if (fd1>fd2)
        fd_max=fd1+1;
    else
        fd_max=fd2+1;

    read_fds=(fd_set *)malloc(sizeof(fd_set));
    if (read_fds==NULL)
    {
        perror("Error allocating space for read_fds in forward()");
        free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
        return -1;
    }

    write_fds=(fd_set *)malloc(sizeof(fd_set));
    if (write_fds==NULL)
    {
        perror("Error allocating space for write_fds in forward()");
        free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
        return -1;
    }

    if ((buffer1=(char *)malloc(65535))==NULL)
    {
        perror("Error allocating memory for buffer1 in forward()");
        free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
        return -1;
    }

    if ((buffer2=(char *)malloc(65535))==NULL)
    {
        perror("Error allocating memory for buffer2 in forward()");
        free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
        return -1;
    }

    /* begin */

    while(1)
    {
        FD_ZERO(read_fds);
        FD_SET(fd1, read_fds);
        FD_SET(fd2, read_fds);

        FD_ZERO(write_fds);
        FD_SET(fd1, write_fds);
        FD_SET(fd2, write_fds);

        if ((fd1_closed==1)&&(fd2_closed==1))
        {
            free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
            return 0;
        }

        select_retval=select(fd_max, read_fds, write_fds, NULL, NULL);

        if (select_retval==(-1))
        {
            if (errno==EINTR) /* should not happen */
            {
                errno=0;
                continue;
            }
            else
            {
                perror("Error in select() in forward()");
                free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
                return -1;
            }
        }

        /* if (select_retval==(0))
            continue; */

        if (FD_ISSET(fd1, read_fds))
        {
            temp=read(fd1, buffer1+buffer_size_used1, 65535-buffer_size_used1);
            if (temp==(-1))
            {
                perror("Error reading data from fd1 in forward()");
                free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
                return -1;
            }
            if (temp==(0))
            {
                if ((buffer_size_used1==0)&&(buffer_size_used2==0))
                {
                    fd1_closed=1;
                    free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
                    return 0; /* connection closed (select() returns readable but nothing to read */
                }
                else
                    fd1_closed=1;
            }

            buffer_size_used1+=temp;
        }

        if (FD_ISSET(fd2, read_fds))
        {
            temp=read(fd2, buffer2+buffer_size_used2, 65535-buffer_size_used2);
            if (temp==(-1))
            {
                perror("Error reading data from fd2 in forward()");
                free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
                return -1;
            }
            if (temp==(0))
            {
                if ((buffer_size_used1==0)&&(buffer_size_used2==0))
                {
                    fd2_closed=1;
                    free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
                    return 0; /* connection closed (select() returns readable but nothing to read */
                }
                else
                    fd2_closed=1;
            }

            buffer_size_used2+=temp;
        }

        if (FD_ISSET(fd1, write_fds))
        {
            errno=0;
            if ((temp=write(fd1, buffer2, buffer_size_used2))==(-1))
            {
                perror("Error writing data to fd1 in forward()");
                free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
                return -1;
            }
            else
            {
                buffer_size_used2-=temp;
                memcpy(buffer2, buffer2+temp, 65535-temp);
            }
        }

        if (FD_ISSET(fd2, write_fds))
        {
            if ((temp=write(fd2, buffer1, buffer_size_used1))==(-1))
            {
                perror("Error writing data to fd2 in forward()");
                free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
                return -1;
            }
            else
            {
                buffer_size_used1-=temp;
                memcpy(buffer1, buffer1+temp, 65535-temp);
            }
        }
    }

    free_forward_fnct_memory(&read_fds, &write_fds, &buffer1, &buffer2);
    return 0;
}

void free_forward_fnct_memory(fd_set **write_fds, fd_set **read_fds, char **buffer1, char **buffer2)
{
    /* free memory used by FUNCTION forward() */

    if (*read_fds!=NULL)
    {
        free(*read_fds);
        *read_fds=NULL;
    }
    if (*write_fds!=NULL)
    {
        free(*write_fds);
        *write_fds=NULL;
    }
    if (*buffer1!=NULL)
    {
        free(*buffer1);
        *buffer1=NULL;
    }
    if (*buffer2!=NULL)
    {
        free(*buffer2);
        *buffer2=NULL;
    }
}
